"<mentor_vim>[mentor_vim_som](syntax file for the light markup langage mentor)
" Vim syntax file
" Language:	mentor hypertext file (not a language but an vim based hypertext environment)
" Maintainer:	Franois Pincemin fpincemin@yahoo.fr
" URL:		
" Last Change:	December 25, 2021
" Version:	1.0-00

" Remove any old syntax stuff hanging around
" related file: syntax.vim [syntax_vim][colortest_vim]
hi col_wh_red	ctermfg=white	ctermbg=red	guifg=white	guibg=red
hi col_bl_green	ctermfg=black	ctermbg=green	guifg=black	guibg=green
hi col_bl_lred	ctermfg=black	ctermbg=lightred	guifg=black	guibg=lightred
hi col_bl_cyan	ctermfg=black	ctermbg=cyan	guifg=black	guibg=cyan
hi col_bl_magenta	ctermfg=black	ctermbg=magenta	guifg=black	guibg=magenta
hi col_lgrey_bl	ctermfg=lightgrey	ctermbg=lightgrey	guifg=lightgrey	guibg=lightgrey	
hi col_bl_grey	ctermfg=black	ctermbg=grey	guifg=black	guibg=grey
hi col_wh_lblue	ctermfg=white	ctermbg=lightblue	guifg=white	guibg=lightblue
hi col_bl_lblue	ctermfg=black	ctermbg=lightblue	guifg=black	guibg=lightblue
syn clear
" shut case off
syn case ignore

"syn region	bloc_mt	matchgroup=bloc_mt_start start="{" matchgroup=NONE end="}" contains=bloc_mt
"hi link bloc_mt_start bloc_mt

syn region	silence_mt	matchgroup=silence_mt_start start="{_" matchgroup=NONE end="_}" contains=bloc_mt
hi link silence_mt_start silence_mt
syntax match	silence_mt_start_end_error "}" contained

"syn region mentorRef		start="\[" end="\]"
"syn region mentorTag		start="<" end=">"
" il y a un caractere qui match _01 _1 _2 etc
"<mentor_color>
syn match mentorRef		"\[.[^ -(){},.;~\]\[]*\]"
syn match mentorTag		"<.[^ -(){},.;~]*>"
syn match mentorWrn		"^\*.*;$"
syn match mentorCSV		"^CSV_.*[;:]"
syn match mentorATT		"(\*.*)"
" these items must and should be customised by user of the mentor hypertext database for useful user keywords
syn match mentorATT		"ATTENTION:"
syn match mentorATT		"IMPORTANT:"
syn match mentorATT		"NOUVEAU:"
syn match mentorWAI		"remarque:"
syn match mentorACT		"ACTION:"
syn match mentorCTL		"<now>"
syn match mentorREU		"RDV:"
syn match mentorCTL		"info:"
syn match mentorCTL		"TODO:"
" Tabulation character
syn match mentorTAB		"	"
" No Break Space character
syn match mentorNBS		""

if !exists("did_mentor_syntax_inits")
	let did_mentor_syntax_inits = 1
	" The default methods for highlighting.  Can be overridden later
	hi link mentorWAI	col_bl_cyan
	hi link mentorWrn	col_bl_lred
	hi link mentorATT	col_wh_red
	hi link mentorACT	col_bl_green
	hi link mentorCTL	col_bl_lred
	hi link mentorREU	col_bl_cyan
	hi link mentorCON	col_bl_magenta
	hi link mentorTAB	col_lgrey_bl
	hi link mentorNBS	col_bl_grey
  hi link mentorTag	Identifier
  hi link mentorRef	Special 
  hi link silence_mt Identifier
  hi link mentorCSV	col_bl_lblue
endif

let b:current_syntax = "mentor"

