#<wordcount_pl>(comptage des mots dans un texet et gnration du dictionnaire du texte)[wordcount_pl_som]
# [wordcount_pl_txt]

#==========================================================
# mappage d'une commande pour utiliser le script dans vim avec le fichier courant
# xwc pour eXecute Word Count
# map &xwc :!\%PERL\% wordcount.pl %
#==========================================================

#<utilisation_du_module_getopt_cal_pl>()
use Getopt::Std;

# La chaine liste_delim permet de controler la definition d'un mot en spcifiant les sparateurs
$liste_delim_reduite=" \n\t,;:.!?/*{}[]()<>|'`\\\"-_=+";
$liste_delim_source=" \n\t,;:.!?/*{}[]()<>|'`\\\"-=+";
$liste_delim_etendue=" \n\t!\"#$%&'()*+,-./:<=>?@[\\]^_`{|}~";
$liste_delim=$liste_delim_etendue;

$debug=0;

#[fonctions_perl_exemple]()
sub trim {
 $_=shift;
 tr/\n/ /;
 s/^\s+//;
 s/\s+$//;
 $_;
}
#[basename_pl]()
sub basename {
 $_=shift;
 $basepath=shift;
 $basefile=shift;
 $baseext=shift;
 $finpath=rindex($_,"/");
 ${$basepath}=substr($_,0,$finpath);
 $basename=substr($_,$finpath+1);
 $debext=rindex($basename,".");
 ${$basefile}=substr($basename,0,$debext);
 ${$baseext}=substr($basename,$debext+1);
 $_=$basename;
 return $_;
}
#[MotSuivant_pl]
#
# arguments:
# texte:  texte  analyser
# mot: mot trouv
# separateurs: liste des sparateurs possibles
# separ:  separateur trouv pour le mot
#
#retour: entier, taille du texte restant  traiter
#
sub MotSuivant
{
 # arguments
 $texte = shift; # String,
 $mot = shift; # String,
 $separateurs = shift; # String,
 $separ = shift; # As String 
 # variable locale
 my $retour; # String
 my $sep; # String
 my $pos; # Integer
 my $fini; # Boolean
 my $taille; # Integer

 $fini = 0;
 $pos = -1;
 $taille = length($texte);
 $mot = "";
	
 if( $taille != 0 )
	{
	 do
		{
		 $pos = $pos + 1;
		 $sep = substr($texte, $pos, 1);
		 if(index($separateurs, $sep) > -1)
			{
			 $separ = $sep;
			 if($sep eq "")
				{
				 $pos = $pos - 1;
				}
			 $texte = substr($texte, $pos + 1, $taille - $pos);
			 $retour = length($texte);
			 $fini = 1;
			}
		 else
			{
			 $mot = $mot.$sep;
			}
		}
	 while ($fini == 0)
	}
 if($debug > 4) { printf("mot:%s,separ:%s\n",$mot,$separ);}

 return $retour;
}
#[San](analyseur syntaxique)
sub San
{
 # arguments
 $mot = shift; # String,
 $separateurs = shift; # String,
 $delimiteurs = shift; # String,
 $separ = shift; # As String 

 # variable locale
 my $retour; # String
 my $sep; # String
 my $pos; # Integer
 my $fini; # Boolean
 my $taille; # Integer

 while ( ($car = getc(STDIN)) ne "")
 {
  $taille++;
	if( ($pos=index($delimiteurs, $car)) > -1 or $deli != 0 ) # c'est un dlimiteur
	 {
	  if( $pos != 0) { $deli = $pos;} # un dlimiteur de chaine est trouv
		elsif( substr($delimiteurs,$deli+1,1) eq $car) { $deli = 0;} # on trouve sa correspondance
		else { $mot = $mot.$car;}
	  next;
	 }
	elsif(index($separateurs, $car) > -1) # c'est un sparateur: fin du mot
	 { 
	  $separ = $car; last; 
	 }
	else # a fait partie du mot
	 {
	  $mot = $mot.$car;
	 }
 }
 return $taille;
}

$base=$ENV{"BASE"}; # chemin de la base mentor 
$ficbasedic=$base."/ht/dicobase.txh";
#<traitements_des_arguments_de_la_ligne_de_commande_mt_to_htm>()
getopts('ds:',\%opt); # <options_de_la_ligne_de_commande_cal_pl>()
$bDico=$opt{'d'}; # -d indicateur de constitution du dictionnaire
$bSep=$opt{'s'}; # -s indicateur du jeu de sparateur utilis
if($bSep eq "s") { $liste_delim=$liste_delim_source;}
elsif($bSep eq "r") { $liste_delim=$liste_delim_reduite;}
elsif($bSep eq "e") { $liste_delim=$liste_delim_etendue;}

if($bDico== 1)
{
#<chargement_du_fichier_dicobase_txt_cal_pl>()
open (basedic_liste, "< $ficbasedic") || die "can't open $ficbasedic : $!";
@file_basedic = <basedic_liste>;
$ii=0;
while ($file_basedic[$ii])
 {
  @lig_basedic = &trim(split(/;/,$file_basedic[$ii].";"));
  $basedic_liste{$lig_basedic[0]} = 1;
  $ii++;
 }
if ($debug) { printf("cardinal_de_basedic_lst=%d\n",$ii);}
}

$bFic = 0;
$ficin=$ARGV[0];

#<lecture_du_fichier_d_entre_mt_to_htm>(on lit le fichier spcifi en argv[0] ou stdin)
if (length("$ficin") )
{
 open (STDIN, "< $ficin") || die "can't open $ficin : $!";
 $bFic = 1;
 &basename($ficin,\$pathin,\$filein,\$extin);
}

$nbMot = 0;
$nbLig = 0;
$nbCar = 0;
while( $ret=&San($mot,$liste_delim,"",$separ) )
{
 $nbCar += $ret;
 if( $separ eq "\n" ) { $nbLig++;}
 if($mot ne "")
	{
   $nbMot++;
   $mot = lc($mot);
   if($basedic_liste{$mot} == 1)
		{
     $nbMotBase++;
		 $dicostd{$mot}++;
		}
	 else
		{
		 $dico{$mot}++;
		}
	 if( $separ eq "\n" ) { $sep="\\n";}
   if ($debug) { printf("separ: %s(%03d) mot: %s\n",$sep,ord($sep),$mot);}
	}
 if($bFic eq "0") 
  { printf("%s%s",$mot,$separ);}
 $mot = "";
}
# resultat
printf("\n{\nnombre de mot=%s, ligne=%s, octet:%s \n}\n",$nbMot,$nbLig,$nbCar);

if($bDico == 1 )
{
 #<ouverture_dico_cal_pl>()
 $ficdic=$pathin.":".$filein."_".$extin.".dic";
 open(SDICO, "> $ficdic") || die "can't open".$ficdic." : $!";

 printf(SDICO "<%s_%s_lex_ana>()[dicobase_txt]\n{\n",$filein,$extin);
 printf(SDICO "<%s_%s_stat>()\n{\n",$filein,$extin);
 printf(SDICO " nombre de mot=%s, ligne=%s, octet:%s \n",$nbMot,$nbLig,$nbCar);
 printf(SDICO " nombre de mot par ligne=%d\n",$nbMot/$nbLig);
 printf(SDICO " nombre de mot hors du dico base=%s\n nombre de mot du dico de base=%s\n}\n",$nbMot-$nbMotBase,$nbMotBase);
 printf("fichier dico=%s\n",$ficdic);
 #<ecriture_dico_cal_pl>()
 printf(SDICO "<%s_%s_dic>()\n{;\n",$filein,$extin);
 printf(SDICO "CSV_COL:cardinal;mot;n;\n");
 printf(SDICO "CSV_TYP:n5;s;n0;\n");
 printf(SDICO "CSV_FOR:;;>1#,,1\n");
 printf(SDICO "CSV_TRI:-1;2;\n");
 printf(SDICO "CSV_CUM:som;nbr;\n");
 while(($key,$value) = each %dico)
	{
	 printf(SDICO "%5d;%s\n",$value,$key);
	}
 printf(SDICO "}\n");
 #<ecriture_dico_std_cal_pl>()
 printf(SDICO "\074%s_%s_std_dic\076()\n{;\n",$filein,$extin);
 printf(SDICO "CSV_COL:cardinal;mot;n;\n");
 printf(SDICO "CSV_TYP:n5;s;n0;\n");
 printf(SDICO "CSV_FOR:;;>1#\n");
 printf(SDICO "CSV_TRI:-1;2;\n");
 printf(SDICO "CSV_CUM:som;nbr;nbr;\n");
 while(($key,$value) = each %dicostd)
	{
	 printf(SDICO "%5d;%s\n",$value,$key);
	}
 printf(SDICO "}\n");
 printf(SDICO "}\n");
}

